package com.ruoyi.web.base.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.framework.web.service.TokenService;
import com.ruoyi.web.base.domain.ProductionWhiteStripBatch;
import com.ruoyi.web.base.service.IProductionWhiteStripBatchService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

import static com.ruoyi.common.core.domain.AjaxResult.success;
import static com.ruoyi.common.utils.SecurityUtils.getUsername;

@RestController
@RequestMapping("/production-white-strip-batch")
public class ProductionWhiteStripBatchController {

    @Autowired
    private IProductionWhiteStripBatchService productionWhiteStripBatchService;
    @Autowired
    private TokenService tokenService;

    @ApiOperation("白条批次添加")
    @PostMapping("/add")
    public AjaxResult add(@RequestBody ProductionWhiteStripBatch batch, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);

        batch.setOrgId(loginOrgId);
        batch.setCreateBy(getUsername());
        return success(productionWhiteStripBatchService.save(batch));
    }

    @ApiOperation("白条批次修改")
    @PostMapping("/edit")
    public AjaxResult edit(@RequestBody ProductionWhiteStripBatch batch, HttpServletRequest request) throws Exception {
        String loginOrgId = tokenService.getLoginOrgId(request);
        batch.setUpdateBy(getUsername());
        return success(productionWhiteStripBatchService.updateById(batch));
    }

    @ApiOperation("白条批次删除")
    @PostMapping("/delete")
    public AjaxResult delete(@RequestBody Map<String, String> paramsMap) {
        String ids = paramsMap.get("ids");
        for (String id : ids.split(",")) {
            productionWhiteStripBatchService.removeById(id);
        }
        return success();
    }

    @ApiOperation("白条批次列表")
    @PostMapping("/list")
    public AjaxResult listAll(HttpServletRequest request) {
        return success(productionWhiteStripBatchService.list(
                new QueryWrapper<ProductionWhiteStripBatch>()
                        .eq("org_id", tokenService.getLoginOrgId(request))
        ));
    }

    @ApiOperation("白条批次分页")
    @GetMapping("/page")
    public AjaxResult page(
            @RequestParam("pageNum") Integer pageNum,
            @RequestParam("pageSize") Integer pageSize,
            HttpServletRequest request
    ) {
        return success(productionWhiteStripBatchService.page(
                new Page<ProductionWhiteStripBatch>(pageNum, pageSize),
                new QueryWrapper<ProductionWhiteStripBatch>()
                        .eq("org_id", tokenService.getLoginOrgId(request))
        ));
    }

    @ApiOperation("白条批次详情")
    @PostMapping("/listById")
    public AjaxResult listById(@RequestBody Map<String, String> paramsMap) {
        String id = paramsMap.get("id");
        return success(productionWhiteStripBatchService.getById(id));
    }
}
